package vostokiolibsample;

import org.vostok.io.Arrays;

/**
 *
 * @author levreau.jerome@vostoksystem.eu
 */
public class TestArrays {

	Object[] obj;

	public static void main(String[] args) {
		TestArrays a = new TestArrays();

		a.testRemove();
		a.testConcat();
		a.testFlatten();
		a.testMove();
		a.testInjectArray();
		a.testInjectObject();
		a.testShift();
	}

	private void createArray() {
		obj = new String[10];

		for (int i = 0; i < 10; i++) {
			obj[i] = Integer.toString(i);
		}
	}

	private void dumpArray() {
		System.out.println("Array : " + obj.length);
		for (int i = 0; i < obj.length; i++) {
			System.out.print(obj[i] + " ");
		}
		System.out.println("");
	}

	public void testRemove() {
		System.out.println("\n\n----------------  remove operation ------------------");
		createArray();

		this.dumpArray();
		this.remove(4, 2);
		this.dumpArray();
		this.remove(0, 3);
		this.dumpArray();
		this.remove(4, 6);
		this.dumpArray();
		this.remove(0, 8);
		this.dumpArray();
	}

	private void remove(int index, int length) {

		System.out.println("removing " + length + " item(s) from " + index);
		obj = Arrays.remove(obj, index, length);
	}

	public void testConcat() {
		System.out.println("\n\n----------------  concat operation ------------------");
		createArray();

		String[] a = new String[]{"100", "101", "102", "103"};
		String[] b = new String[]{"a", "b", "c", "d"};
		String[] c = new String[]{"A", "B"};

		this.dumpArray();
		System.out.println("--> add 1 array with 4 items (100->103)");
		this.obj = Arrays.concat(this.obj, a);
		this.dumpArray();
		System.out.println("add 2 arrays with 4 and 2 items");
		this.obj = Arrays.concat(this.obj, b, c);
		this.dumpArray();
	}

	public void testFlatten() {
		System.out.println("\n\n----------------  flatten operation ------------------");
		createArray();

		Object[] tab = new Object[3];
		tab[0] = new String[]{"100", "101", "102", "103"};
		tab[1] = new String[]{"a", "b", "c", "d"};
		tab[2] = new String[]{"A", "B"};

		System.out.println("Flattening 3 arrays with 4, 4 and 2 items ...");
		this.obj = Arrays.flatten(tab);
		this.dumpArray();
	}

	public void testMove() {
		System.out.println("\n\n----------------  move operation ------------------");
		createArray();

		this.dumpArray();
		System.out.println("move 6 to 2");
		Arrays.move(obj, 6, 2);
		this.dumpArray();
		System.out.println("move 1 to 8");
		Arrays.move(obj, 1, 8);
		this.dumpArray();
		System.out.println("move 9 to 0");
		Arrays.move(obj, 9, 0);
		this.dumpArray();
		System.out.println("move 3 to 9 (value of 2 to 1)");
		Arrays.move(obj, 3, 9);
		this.dumpArray();
	}

	public void testInjectArray() {
		System.out.println("\n\n----------------  inject operation ------------------");
		createArray();

		String[] a = new String[]{"100", "101", "102", "103"};
		String[] b = new String[]{"a", "b", "c", "d"};
		String[] c = new String[]{"A", "B"};

		this.dumpArray();

		System.out.println("inject an array of 4 items at index 2");
		this.obj = Arrays.inject(obj, 2, a);
		this.dumpArray();
		System.out.println("append an array of 4 items to the end");
		this.obj = Arrays.inject(obj, 20, b);
		this.dumpArray();

		System.out.println("prepend an array of 2 items at the begining");
		this.obj = Arrays.inject(obj, 0, c);
		this.dumpArray();
	}

	public void testInjectObject() {


		System.out.println("Test injection d'objets");
		this.dumpArray();

		System.out.println("injecte 1 objet à 4");
		this.obj = Arrays.inject(obj, 4, "a", 1);
		this.dumpArray();

		System.out.println("injecte 2 objets à la fin");
		this.obj = Arrays.inject(obj, 40, "b", 2);
		this.dumpArray();

		System.out.println("injecte 2 objets au début");
		this.obj = Arrays.inject(obj, 0, "c", 2);
		this.dumpArray();

		System.out.println("injecte 1 objet à 14");
		this.obj = Arrays.inject(obj, 14, "d", 1);
		this.dumpArray();
	}

	public void testShift() {
		System.out.println("\n\n----------------  shifting operation ------------------");
		createArray();

		this.dumpArray();

		System.out.println("shift to the left 3 items from index 4 of 2");
		Arrays.shiftLeft(obj, 4, 3, 2);
		this.dumpArray();

		System.out.println("shift to the left 2 items from index 3 of 10");
		Arrays.shiftLeft(obj, 3, 2, 10);
		this.dumpArray();

		System.out.println("shift to the right 3 items from index 5 of 10");
		Arrays.shiftRight(obj, 5, 3, 10);
		this.dumpArray();

		System.out.println("shift to the right 2 items from index 3 of 3");
		Arrays.shiftRight(obj, 3, 2, 3);
		this.dumpArray();

		System.out.println("shift to the left 2 items from index 8 of 1");
		Arrays.shiftLeft(obj, 8, 2, 1);
		this.dumpArray();

		System.out.println("shift to the right 3 items from index 0 of 1");
		Arrays.shiftRight(obj, 0, 3, 1);
		this.dumpArray();
	}
}
